<template>
    <form @submit.prevent="submitSearchForm" class="flex items-end gap-3 mb-4">
        <div class="form-control">
            <div>Tên khóa học:</div>
            <label for="name-public">
                <input
                    v-model="name"
                    id="name-public"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                    placeholder="Tên khóa học..."
                    autocomplete="off"
                />
            </label>
        </div>
        <div class="form-control">
            <label for="category-public">
                <div>Môn học:</div>
                <select
                    v-model="category"
                    id="category-public"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                >
                    <option value="">Tất cả</option>
                    <option
                        :key="category.id"
                        v-for="category in SELECT_OPTION_COURSE_CATEGORY"
                        :value="category.id"
                    >
                        {{ category.text }}
                    </option>
                </select>
            </label>
        </div>
        <BasicButton
            type="submit"
            classCustom="bg-color-warning hover:shadow-hover-warning"
        >
            <ChatIcon class="text-white" />
            <span>Tìm kiếm</span>
        </BasicButton>
    </form>
    <table>
        <thead>
            <tr>
                <th>Thông tin khóa học</th>
                <th class="text-center">Môn học</th>
                <th class="text-center">Thời gian tạo</th>
                <th class="text-center">Người duyệt</th>
                <th class="text-center">Hành động</th>
            </tr>
        </thead>
        <tbody>
            <template v-if="!isLoading">
                <template v-if="coursesComputed && coursesComputed.length">
                    <tr :key="course.id" v-for="course in coursesComputed">
                        <td class="w-400">
                            <div class="flex gap-3">
                                <img
                                    :src="
                                        course.course_image
                                            ? course.course_image
                                            : require('@/assets/images/no-image.webp')
                                    "
                                    class="w-28 min-w-28 h-full"
                                    alt=""
                                />
                                <div>
                                    <div class="text-lg font-semibold">
                                        {{ course.course_name }}
                                    </div>
                                    <p class="text-sm mb-1">
                                        Tổng số bài học:
                                        {{ course.total_lesson }}
                                    </p>
                                    <p class="text-sm mb-1">
                                        Tác giả:
                                        <router-link
                                            :to="{
                                                name: 'admin-user-view',
                                                params: {
                                                    userId: course.created_by.id
                                                }
                                            }"
                                            class="inline-block bg-color-primary text-white text-xs rounded-2xl px-2 py-1"
                                        >
                                            {{ course.created_by.name }}
                                        </router-link>
                                    </p>
                                </div>
                            </div>
                        </td>
                        <td class="text-center">
                            {{ course.course_category }}
                        </td>
                        <td class="text-center">{{ course.created_at }}</td>
                        <td class="text-center">
                            <router-link
                                :to="{
                                    name: 'admin-user-view',
                                    params: {
                                        userId: course.teacher_approval?.id
                                    }
                                }"
                                class="text-main-color"
                            >
                                {{ course.teacher_approval?.name }}
                            </router-link>
                        </td>
                        <td>
                            <div
                                class="box-actions flex items-center justify-center gap-1"
                            >
                                <router-link
                                    :to="{
                                        name: 'admin-course-view',
                                        params: { courseId: course.course_id },
                                        hash: '#overview'
                                    }"
                                    v-tooltip="'Xem'"
                                    class="action-view"
                                >
                                    <EyeIcon />
                                </router-link>
                                <a
                                    v-if="!course.teacher_approval"
                                    @click="showModal(course.course_id)"
                                    href="javascript:void(0)"
                                    v-tooltip="'Gán người kiểm duyệt'"
                                    class="action-approval"
                                >
                                    <BadgeCheckIcon />
                                </a>
                            </div>
                        </td>
                    </tr>
                </template>
                <template v-else>
                    <tr class="no-data-table">
                        <td colspan="6" class="text-center">
                            Không có dữ liệu
                        </td>
                    </tr>
                </template>
            </template>
            <template v-else>
                <tr>
                    <td colspan="6" class="text-center">
                        <SpinLoading />
                    </td>
                </tr>
            </template>
        </tbody>
    </table>
    <div
        v-if="!isLoading && coursesComputed && coursesComputed.length"
        class="flex justify-end p-6"
    >
        <BasicPagination
            @onClickPage="onClickPage"
            :currentPage="currentPage"
            :lastPage="lastPage"
        />
    </div>

    <teleport to="body">
        <Modal v-model:isActiveModal="isActiveModal">
            <template v-slot:header><h4>Gán người kiểm duyệt</h4></template>
            <template v-slot:body>
                <div class="form-control">
                    <label class="flex flex-col" for="teacher-approval">
                        <div>Giáo viên <span class="text-red-500">*</span></div>
                        <select
                            v-model="teacherIdApproval"
                            id="teacher-approval"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                            :class="{
                                'border-red-400': errorTeacherIdApproval
                            }"
                        >
                            <option disabled value="">
                                Chọn giáo viên kiểm duyệt
                            </option>
                            <option
                                :key="teacher.id"
                                v-for="teacher in listUserWithPermission"
                                :value="teacher.id"
                            >
                                {{ teacher.name }}
                            </option>
                        </select>
                    </label>
                    <div
                        v-if="errorTeacherIdApproval"
                        class="text-left text-sm text-red-500 mt-1"
                    >
                        {{ errorTeacherIdApproval }}
                    </div>
                </div>
            </template>
            <template v-slot:btnSave>
                <BasicButton
                    @click="onSubmitTeacherApproval"
                    type="submit"
                    classCustom="flex item-center gap-2 bg-color-primary hover:shadow-hover-primary"
                >
                    <SpinLoading
                        v-if="isLoadingCreateTeacherApproval"
                        color="#ffffff"
                        size="15"
                    />
                    <span>Gán</span>
                </BasicButton>
            </template>
        </Modal>
    </teleport>
</template>

<script>
import { computed, ref, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import { ROLE_TEACHER, SELECT_OPTION_COURSE_CATEGORY } from "@/constants";
import timeHelper from "@/helper/timeHelper";
import { createToast } from "mosha-vue-toastify";

import useFetchAllCoursePending from "@/hooks/course/useFetchAllCoursePending";
import useFetchAllUserPermission from "@/hooks/user/useFetchAllUserPermission";
import useCreateTeacherApprovalCourse from "@/hooks/course/useCreateTeacherApprovalCourse";

import { ChatIcon, EyeIcon, BadgeCheckIcon } from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import BasicPagination from "@/components/pagination/BasicPagination.vue";
import Modal from "@/components/modal/Modal.vue";

export default {
    components: {
        ChatIcon,
        EyeIcon,
        BadgeCheckIcon,
        SpinLoading,
        BasicButton,
        BasicPagination,
        Modal
    },
    setup() {
        const route = useRoute();
        const router = useRouter();
        const courses = ref([]);
        const {
            isLoading,
            listCourse,
            onFetchAllCoursePending
        } = useFetchAllCoursePending();
        const {
            listUserWithPermission,
            onFetchAllUserPermission
        } = useFetchAllUserPermission();
        const {
            errorResponse,
            isLoadingCreateTeacherApproval,
            onCreateTeacherApproval
        } = useCreateTeacherApprovalCourse();

        async function onFetch() {
            await onFetchAllCoursePending(route.query);
            courses.value = listCourse.value;

            await onFetchAllUserPermission(ROLE_TEACHER);
        }
        onFetch();

        const coursesComputed = computed(() => {
            if (courses.value && courses.value.length) {
                return courses.value.map(course => {
                    let course_category;
                    SELECT_OPTION_COURSE_CATEGORY.forEach(category => {
                        if (course.course_category === category.id)
                            course_category = category.text;
                    });
                    return {
                        ...course,
                        course_category,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(course.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        // search
        const name = ref(route.query.name || null);
        const category = ref(route.query.category || "");
        async function submitSearchForm() {
            await onFetchAllCoursePending({
                name: name.value,
                category: category.value
            });
            courses.value = listCourse.value;

            const path = route.path;
            const hash = route.hash;

            let query = {};
            if (name.value) query = { ...query, name: name.value };
            if (category.value !== null && category.value !== "")
                query = { ...query, category: category.value };

            router.push({ path, query, hash });
        }

        // update currentPge and lastPage when change listCourse
        const currentPage = ref(1);
        const lastPage = ref(1);
        watch(listCourse, newValue => {
            currentPage.value = newValue.current_page;
            lastPage.value = newValue.last_page;
        });

        // click pagination
        async function onClickPage(value) {
            router.push({
                path: route.path,
                query: { ...route.query, page: value },
                hash: route.hash
            });

            await onFetchAllCoursePending({ ...route.query, page: value });
            courses.value = listCourse.value;
        }

        // modal
        const isActiveModal = ref(false);
        const courseIdApproval = ref(null);
        const teacherIdApproval = ref("");
        const errorTeacherIdApproval = ref(null);
        function showModal(courseId) {
            isActiveModal.value = true;
            courseIdApproval.value = courseId;
        }
        async function onSubmitTeacherApproval() {
            if (teacherIdApproval.value === "") {
                errorTeacherIdApproval.value =
                    "Bạn chưa chọn giáo viên kiểm duyệt";
            } else {
                errorTeacherIdApproval.value = null;
                await onCreateTeacherApproval(
                    teacherIdApproval.value,
                    courseIdApproval.value
                );
                isActiveModal.value = false;

                if (errorResponse.value) {
                    createToast(errorResponse.value, {
                        showIcon: true,
                        type: "danger"
                    });
                } else {
                    createToast("Gán thành công", {
                        showIcon: true,
                        type: "success"
                    });
                }
            }
        }

        return {
            SELECT_OPTION_COURSE_CATEGORY,
            isLoading,
            coursesComputed,
            listUserWithPermission,
            isLoadingCreateTeacherApproval,
            name,
            category,
            submitSearchForm,
            currentPage,
            lastPage,
            onClickPage,
            isActiveModal,
            courseIdApproval,
            teacherIdApproval,
            errorTeacherIdApproval,
            showModal,
            onSubmitTeacherApproval
        };
    }
};
</script>
